/*
 * RANDOM.H
 * By Joshua Levy
 * Header file for any program using random.c
 *
 * See random.c for documentation.
 */

#ifndef RANDOM_H
#define RANDOM_H 1

extern char *ra_card() ;
extern int ra_roll() ;
extern int ra_random() ;
extern int ra_query() ;
extern void ra_seed() ;
extern int ra_logging() ;
extern double ra_float() ;

/* The current version of the random routines */
#define RA_VERSION 2

/* states, to be passed as the first argument to ra_logging */
#define RA_NORMAL   0
#define RA_PLAY     1
#define RA_LOG      2

/* errors, returned from those routines which return integers */
#define RA_OK         0      /* success */
#define RA_E_STATE  -100
#define RA_E_NOFILE -101
#define RA_E_BADQUERY -102

/* types of queries */
#define RA_MAX 1
#define RA_MIN 2
#define RA_AVE 3
#define RA_LEGAL 4

#endif
