/*
 * TABLESIMPBIG.C
 * Code supporting rolling on big but simple tables
 * By Joshua Levy  
 *
 * COMPILING
 *
% cc -g -c tablesimpbig.c 
 */

#include <stdio.h>
#include <assert.h>
#include <string.h>
#include <ctype.h>

#include "table.h"


int tb_simpbig_read(rt,fp,title) table_t **rt ; FILE *fp ; char *title ; 
{
    simpletable_t *t ;
    simplerow_t *row ;
    char buf[1000] ;
    char roll[10] ;
    int rows ;
    int sts ;
    int r,i ;
    int lines ;
    char *cp ;

    sts = (int)fgets(buf,sizeof(buf),fp) ;
    assert(sts) ;
    sts = sscanf(buf,"%s %d",roll,&rows) ;
    assert(sts==2) ;
    t = (simpletable_t*)
	MALLOC(sizeof(simpletable_t)+sizeof(simplerow_t)*(rows-1)) ;
    assert(t) ;
    t->title = strdup(title) ;
    strncpy(t->roll,roll,sizeof(t->roll)) ;
    t->numrows = rows ;
    sts = (int)fgets(buf,sizeof(buf),fp) ;
    assert(sts) ;
    t->source = strdup(strtok(buf,"\n")) ;
    for(r=0 ; r<rows ; r++) {
	sts = (int)fgets(buf,sizeof(buf),fp) ;
	assert(sts) ;
	row = &t->rows[r] ;
	sts=parse_range(strtok(buf,"\t\n"),&row->first,&row->last);
	assert(sts>0) ;
	lines = atoi(strtok((char*)0,"\n")) ;
	row->result = (char*)malloc(132*lines+1) ;
	assert(row->result) ;
	for(i=0,cp=row->result ; i<lines ; i++) {
	    sts = (int)fgets(cp,(unsigned)132,fp) ;
	    assert(sts) ;
	    cp += strlen(cp) ;
	}
	*cp = '\0' ;
    }
    *rt = (table_t*)t ;
    return 0 ;
}

int tb_simpbig_print(tab,fp,way) table_t *tab ; FILE *fp ; int way ;
{
    simpletable_t *t ;
    char tmp[10] ;
    int r ;

    t = (simpletable_t*)tab ;
    switch (way) {
      case 1:
	fprintf(fp,".TS\ncB s\ncI s\n") ;
	fprintf(fp,"r lw(5i).\n") ;
	fprintf(fp,"%s\n",t->title) ;
	fprintf(fp,"(roll %s)\n",t->roll) ;
	for(r=0 ; r<t->numrows ; r++) {
	    if (t->rows[r].first==t->rows[r].last)
		sprintf(tmp,"%d",t->rows[r].first) ;
	    else
		sprintf(tmp,"%d-%d",t->rows[r].first,t->rows[r].last) ;
	    fprintf(fp,"%s\tT{\n%sT}\n",tmp,t->rows[r].result) ;
	}
	fprintf(fp,".TE\n") ;
	break ;
      default:
	return TB_E_NOTYET ;
    }
    return TB_OK ;
}
